diff --git a/libr/core/anal.c b/libr/core/anal.c
index 1a948d10cd5..346c6a5333f 100644
--- a/libr/core/anal.c
+++ b/libr/core/anal.c
@@ -222,6 +222,19 @@ R_API ut64 r_core_anal_address (RCore *core, ut64 addr) {
 	return types;
 }
 
+R_API void *r_core_anal_autoname_all_fcns(RCore *core) {
+	RListIter *it;
+	RAnalFunction *fcn;
+	r_list_foreach (core->anal->fcns, it, fcn) {
+		char *name = r_core_anal_fcn_autoname (core, fcn->addr, 0);
+		if (name) {
+			r_flag_rename (core->flags, r_flag_get (core->flags, fcn->name), name);
+			free (fcn->name);
+			fcn->name = strdup (name);
+		}
+		free (name);
+	}
+}
 /* suggest a name for the function at the address 'addr'.
  * If dump is true, every strings associated with the function is printed */
 R_API char *r_core_anal_fcn_autoname(RCore *core, ut64 addr, int dump) {
diff --git a/libr/core/cmd_anal.c b/libr/core/cmd_anal.c
index 97a200d5340..f9ea59991c3 100644
--- a/libr/core/cmd_anal.c
+++ b/libr/core/cmd_anal.c
@@ -891,8 +891,7 @@ static int cmd_anal_fcn(RCore *core, const char *input) {
 			{
 			char *name = r_core_anal_fcn_autoname (core, core->offset, 0);
 			if (name) {
-				r_cons_printf ("afn %s 0x%08" PFMT64x "\n",
-					name, core->offset);
+				r_cons_printf ("afn %s 0x%08" PFMT64x "\n", name, core->offset);
 				free (name);
 			}
 			}
@@ -3588,6 +3587,7 @@ static int cmd_anal_all(RCore *core, const char *input) {
 		"aas", " [len]", "analyze symbols (af @@= `isq~[0]`)",
 		"aat", " [len]", "analyze all consecutive functions in section",
 		"aap", "", "find and analyze function preludes",
+		"aau", "", "autoname all fcns",
 		NULL };
 
 	switch (*input) {
@@ -3602,7 +3602,8 @@ static int cmd_anal_all(RCore *core, const char *input) {
 		r_core_cmd0 (core, "af @@= `isq~[0]`");
 		r_core_cmd0 (core, "af @ entry0");
 		break;
-	case 'n': r_core_cmd0 (core, ".afna @@ fcn.*"); break;
+	case 'n': r_core_cmd0 (core, ".afna @@ fcn.*"); break; //aan
+	case 'u': r_core_anal_autoname_all_fcns (core); break; //aau
 	case 'p': // "aap"
 		if (*input == '?') {
 			// TODO: accept parameters for ranges
@@ -3654,11 +3655,9 @@ static int cmd_anal_all(RCore *core, const char *input) {
 					eprintf ("[*] Use -AA or aaaa to perform additional experimental analysis.\n");
 				}
 				r_config_set_i (core->config, "anal.calls", c);
-				if (r_config_get_i (core->config, "anal.autoname")) {
-					rowlog (core, "Construct a function name for all fcn.* (.afna @@ fcn.*)");
-					r_core_cmd0 (core, ".afna @@ fcn.*");
-					rowlog_done (core);
-				}
+				rowlog (core, "Construct a function name for all fcns");
+				r_core_anal_autoname_all_fcns (core);
+				rowlog_done (core);
 				if (core->cons->breaked)
 					goto jacuzzi;
 				r_core_cmd0 (core, "s-");
diff --git a/libr/include/r_core.h b/libr/include/r_core.h
index 60951c76ea5..06cedbccd26 100644
--- a/libr/include/r_core.h
+++ b/libr/include/r_core.h
@@ -339,6 +339,7 @@ R_API ut64 r_core_anal_get_bbaddr(RCore *core, ut64 addr);
 R_API int r_core_anal_bb_seek(RCore *core, ut64 addr);
 R_API int r_core_anal_fcn(RCore *core, ut64 at, ut64 from, int reftype, int depth);
 R_API char *r_core_anal_fcn_autoname(RCore *core, ut64 addr, int dump);
+R_API void *r_core_anal_autoname_all_fcns(RCore *core);
 R_API int r_core_anal_fcn_list(RCore *core, const char *input, int rad);
 R_API int r_core_anal_fcn_list_size(RCore *core);
 R_API void r_core_anal_fcn_labels(RCore *core, RAnalFunction *fcn, int rad);
